Get started writing data
- 2 / 3
This tutorial walks you through the fundamental of creating line protocol data and writing it to InfluxDB.
InfluxDB provides many different options for ingesting or writing data, including the following:
- Influx user interface (UI)
- InfluxDB HTTP API (v1 and v2)
- Telegraf
influx3data CLI- InfluxDB client libraries
influxCLI
If using tools like Telegraf or InfluxDB client libraries, they can build the line protocol for you, but it’s good to understand how line protocol works.
Line protocol
All data written to InfluxDB is written using line protocol, a text-based format that lets you provide the necessary information to write a data point to InfluxDB. This tutorial covers the basics of line protocol, but for detailed information, see the Line protocol reference.
Line protocol elements
Each line of line protocol contains the following elements:
* Required- * measurement: String that identifies the measurement to store the data in.
- tag set: Comma-delimited list of key value pairs, each representing a tag. Tag keys and values are unquoted strings. Spaces, commas, and equal characters must be escaped.
- * field set: Comma-delimited list of key value pairs, each representing a field. Field keys are unquoted strings. Spaces and commas must be escaped. Field values can be strings (quoted), floats, integers, unsigned integers, or booleans.
- timestamp: Unix timestamp associated with the data. InfluxDB supports up to nanosecond precision. If the precision of the timestamp is not in nanoseconds, you must specify the precision when writing the data to InfluxDB.
Line protocol element parsing
- measurement: Everything before the first unescaped comma before the first whitespace.
- tag set: Key-value pairs between the first unescaped comma and the first unescaped whitespace.
- field set: Key-value pairs between the first and second unescaped whitespaces.
- timestamp: Integer value after the second unescaped whitespace.
- Lines are separated by the newline character (
\n). Line protocol is whitespace sensitive.
myMeasurement,tag1=val1,tag2=val2 field1="v1",field2=1i 0000000000000000000
For schema design recommendations, see InfluxDB schema design.
Construct line protocol
With a basic understanding of line protocol, you can now construct line protocol and write data to InfluxDB. Consider a use case where you collect data from sensors in your home. Each sensor collects temperature, humidity, and carbon monoxide readings. To collect this data, use the following schema:
- measurement:
home- tags
room: Living Room or Kitchen
- fields
temp: temperature in °C (float)hum: percent humidity (float)co: carbon monoxide in parts per million (integer)
- timestamp: Unix timestamp in second precision
- tags
The following line protocol sample represents data collected hourly beginning at 2022-01-01T08:00:00Z (UTC) until 2022-01-01T20:00:00Z (UTC).
Home sensor data line protocol
home,room=Living\ Room temp=21.1,hum=35.9,co=0i 1719924000
home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719924000
home,room=Living\ Room temp=21.4,hum=35.9,co=0i 1719927600
home,room=Kitchen temp=23.0,hum=36.2,co=0i 1719927600
home,room=Living\ Room temp=21.8,hum=36.0,co=0i 1719931200
home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719931200
home,room=Living\ Room temp=22.2,hum=36.0,co=0i 1719934800
home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719934800
home,room=Living\ Room temp=22.2,hum=35.9,co=0i 1719938400
home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719938400
home,room=Living\ Room temp=22.4,hum=36.0,co=0i 1719942000
home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719942000
home,room=Living\ Room temp=22.3,hum=36.1,co=0i 1719945600
home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719945600
home,room=Living\ Room temp=22.3,hum=36.1,co=1i 1719949200
home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719949200
home,room=Living\ Room temp=22.4,hum=36.0,co=4i 1719952800
home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719952800
home,room=Living\ Room temp=22.6,hum=35.9,co=5i 1719956400
home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719956400
home,room=Living\ Room temp=22.8,hum=36.2,co=9i 1719960000
home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719960000
home,room=Living\ Room temp=22.5,hum=36.3,co=14i 1719963600
home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719963600
home,room=Living\ Room temp=22.2,hum=36.4,co=17i 1719967200
home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719967200Write line protocol to InfluxDB
The following examples show how to write the preceding sample data, already in line protocol format, to an InfluxDB Cloud Serverless bucket.
To learn more about available tools and options, see Write data.
Some examples in this getting started tutorial assume your InfluxDB credentials (URL, organization, and token) are provided by environment variables.
Go to cloud2.influxdata.com in a browser to log in and access the InfluxDB UI.
Navigate to Load Data > Buckets using the left navigation bar.
Load Data
- Click Add Data on the bucket you want to write the data to and select Line Protocol.
- Select Enter Manually.
- Important In the Precision drop-down menu above the line protocol text field, select Seconds (to match to precision of the timestamps in the line protocol).
- Copy the line protocol above and paste it into the line protocol text field.
- Click Write Data.
The UI confirms that the data has been written successfully.
If you haven’t already, download, install, and configure the
influxCLI.Use the
influx writecommand to write the preceding line protocol to InfluxDB.Provide the following:
-b, --bucketor--bucket-idflag with the bucket name or ID to write do.-p, --precisionflag with the timestamp precision (s).- String-encoded line protocol.
- Connection and authentication credentials
influx write \
--bucket get-started \
--precision s "
home,room=Living\ Room temp=21.1,hum=35.9,co=0i 1719924000
home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719924000
home,room=Living\ Room temp=21.4,hum=35.9,co=0i 1719927600
home,room=Kitchen temp=23.0,hum=36.2,co=0i 1719927600
home,room=Living\ Room temp=21.8,hum=36.0,co=0i 1719931200
home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719931200
home,room=Living\ Room temp=22.2,hum=36.0,co=0i 1719934800
home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719934800
home,room=Living\ Room temp=22.2,hum=35.9,co=0i 1719938400
home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719938400
home,room=Living\ Room temp=22.4,hum=36.0,co=0i 1719942000
home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719942000
home,room=Living\ Room temp=22.3,hum=36.1,co=0i 1719945600
home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719945600
home,room=Living\ Room temp=22.3,hum=36.1,co=1i 1719949200
home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719949200
home,room=Living\ Room temp=22.4,hum=36.0,co=4i 1719952800
home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719952800
home,room=Living\ Room temp=22.6,hum=35.9,co=5i 1719956400
home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719956400
home,room=Living\ Room temp=22.8,hum=36.2,co=9i 1719960000
home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719960000
home,room=Living\ Room temp=22.5,hum=36.3,co=14i 1719963600
home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719963600
home,room=Living\ Room temp=22.2,hum=36.4,co=17i 1719967200
home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719967200
"If successful, the output is the success message; otherwise, error details and the failure message.
Use Telegraf to consume line protocol, and then write it to InfluxDB Cloud Serverless.
If you haven’t already, follow the instructions to download and install Telegraf.
Copy and save the home sensor data sample to a file on your local system–for example,
home.lp.cat <<- EOF > home.lp home,room=Living\ Room temp=21.1,hum=35.9,co=0i 1719924000 home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719924000 home,room=Living\ Room temp=21.4,hum=35.9,co=0i 1719927600 home,room=Kitchen temp=23.0,hum=36.2,co=0i 1719927600 home,room=Living\ Room temp=21.8,hum=36.0,co=0i 1719931200 home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719931200 home,room=Living\ Room temp=22.2,hum=36.0,co=0i 1719934800 home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719934800 home,room=Living\ Room temp=22.2,hum=35.9,co=0i 1719938400 home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719938400 home,room=Living\ Room temp=22.4,hum=36.0,co=0i 1719942000 home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719942000 home,room=Living\ Room temp=22.3,hum=36.1,co=0i 1719945600 home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719945600 home,room=Living\ Room temp=22.3,hum=36.1,co=1i 1719949200 home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719949200 home,room=Living\ Room temp=22.4,hum=36.0,co=4i 1719952800 home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719952800 home,room=Living\ Room temp=22.6,hum=35.9,co=5i 1719956400 home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719956400 home,room=Living\ Room temp=22.8,hum=36.2,co=9i 1719960000 home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719960000 home,room=Living\ Room temp=22.5,hum=36.3,co=14i 1719963600 home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719963600 home,room=Living\ Room temp=22.2,hum=36.4,co=17i 1719967200 home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719967200 EOFRun the following command to generate a Telegraf configuration file (
./telegraf.conf) that enables theinputs.fileandoutputs.influxdb_v2plugins:telegraf --sample-config \ --input-filter file \ --output-filter influxdb_v2 \ > telegraf.confIn your editor, open
./telegraf.confand configure the following:fileinput plugin: In the[[inputs.file]].fileslist, replace"/tmp/metrics.out"with your sample data filename. If Telegraf can’t find a file when started, it stops processing and exits.[[inputs.file]] ## Files to parse each interval. Accept standard unix glob matching rules, ## as well as ** to match recursive files and directories. files = ["home.lp"]output-influxdb_v2output plugin: In the[[outputs.influxdb_v2]]section, replace the default values with the following configuration for your InfluxDB Cloud Serverless bucket:[[outputs.influxdb_v2]] # InfluxDB Cloud Serverless URL urls = ["${INFLUX_HOST}"] # INFLUX_TOKEN is an environment variable you assigned to your API token token = "${INFLUX_TOKEN}" # An empty string (InfluxDB ignores this parameter) organization = "" # Bucket name bucket = "get-started"The example configuration uses the following InfluxDB credentials:
urls: an array containing yourINFLUX_HOSTenvironment variabletoken: yourINFLUX_TOKENenvironment variableorganization: an empty string (InfluxDB ignores this parameter)bucket: the name of the bucket to write to
To write the data, start the
telegrafdaemon with the following options:--config: Specifies the path of the configuration file.--once: Runs a single Telegraf collection cycle for the configured inputs and outputs, and then exits.
Enter the following command in your terminal:
telegraf --once --config ./telegraf.confIf the write is successful, the output is similar to the following:
2023-05-31T20:09:08Z D! [agent] Starting service inputs 2023-05-31T20:09:19Z D! [outputs.influxdb_v2] Wrote batch of 52 metrics in 348.008167ms 2023-05-31T20:09:19Z D! [outputs.influxdb_v2] Buffer fullness: 0 / 10000 metrics
Telegraf and its plugins provide many options for reading and writing data. To learn more, see how to use Telegraf to write data.
Write data with your existing workloads that already use the InfluxDB v1 /write
API endpoint.
If migrating data from InfluxDB 1.x, see the Migrate data from InfluxDB 1.x to InfluxDB InfluxDB Cloud Serverless guide.
To write data to InfluxDB using the
InfluxDB v1 HTTP API, send a request
to the
InfluxDB API /write endpoint
using the POST request method.
POST https://cloud2.influxdata.com/write
Include the following with your request:
- Headers:
- Authorization: Token <INFLUX_TOKEN>
- Content-Type: text/plain; charset=utf-8
- Accept: application/json
- Query parameters:
- db: InfluxDB bucket name
- precision:timestamp precision (default is
ns) - rp: retention policy name (default is the default DBRP mapping, if it exists, for the namespace; otherwise, an auto-generated DBRP mapping).
- Request body: Line protocol as plain text
The following example uses cURL and the InfluxDB v1 API to write line protocol
to InfluxDB.
Given that API_TOKEN is an
All-Access API token,
InfluxDB creates a bucket named get-started/autogen and an
autogen DBRP mapping, and then writes the data to the bucket.
response=$(curl --silent --write-out "%{response_code}:-%{errormsg}" \
"https://cloud2.influxdata.com
/write?db=get-started&precision=s" \
--header "Authorization: Token API_TOKEN" \
--header "Content-type: text/plain; charset=utf-8" \
--header "Accept: application/json" \
--data-binary "
home,room=Living\ Room temp=21.1,hum=35.9,co=0i 1641024000
home,room=Kitchen temp=21.0,hum=35.9,co=0i 1641024000
home,room=Living\ Room temp=21.4,hum=35.9,co=0i 1641027600
home,room=Kitchen temp=23.0,hum=36.2,co=0i 1641027600
home,room=Living\ Room temp=21.8,hum=36.0,co=0i 1641031200
home,room=Kitchen temp=22.7,hum=36.1,co=0i 1641031200
home,room=Living\ Room temp=22.2,hum=36.0,co=0i 1641034800
home,room=Kitchen temp=22.4,hum=36.0,co=0i 1641034800
home,room=Living\ Room temp=22.2,hum=35.9,co=0i 1641038400
home,room=Kitchen temp=22.5,hum=36.0,co=0i 1641038400
home,room=Living\ Room temp=22.4,hum=36.0,co=0i 1641042000
home,room=Kitchen temp=22.8,hum=36.5,co=1i 1641042000
home,room=Living\ Room temp=22.3,hum=36.1,co=0i 1641045600
home,room=Kitchen temp=22.8,hum=36.3,co=1i 1641045600
home,room=Living\ Room temp=22.3,hum=36.1,co=1i 1641049200
home,room=Kitchen temp=22.7,hum=36.2,co=3i 1641049200
home,room=Living\ Room temp=22.4,hum=36.0,co=4i 1641052800
home,room=Kitchen temp=22.4,hum=36.0,co=7i 1641052800
home,room=Living\ Room temp=22.6,hum=35.9,co=5i 1641056400
home,room=Kitchen temp=22.7,hum=36.0,co=9i 1641056400
home,room=Living\ Room temp=22.8,hum=36.2,co=9i 1641060000
home,room=Kitchen temp=23.3,hum=36.9,co=18i 1641060000
home,room=Living\ Room temp=22.5,hum=36.3,co=14i 1641063600
home,room=Kitchen temp=23.1,hum=36.6,co=22i 1641063600
home,room=Living\ Room temp=22.2,hum=36.4,co=17i 1641067200
home,room=Kitchen temp=22.7,hum=36.5,co=26i 1641067200
")
# Format the response code and error message output.
response_code=${response%%:-*}
errormsg=${response#*:-}
# Remove leading and trailing whitespace from errormsg
errormsg=$(echo "${errormsg}" | tr -d '[:space:]')
echo "$response_code"
if [[ $errormsg ]]; then
echo "$response"
fiReplace the following:
API_TOKEN: a token with sufficient permissions to the specified bucket. For InfluxDB to auto-generate the DBRP mapping, you must use an All-Access API token in the write request.
If successful, the output is an HTTP 204 No Content status code; otherwise,
the error status code and failure message.
204To write data to InfluxDB using the
InfluxDB v2 HTTP API, send a request
to the InfluxDB API /api/v2/write endpoint using the POST request method.
POST https://cloud2.influxdata.com/api/v2/write
Include the following with your request:
- Headers:
- Authorization: Token <INFLUX_TOKEN>
- Content-Type: text/plain; charset=utf-8
- Accept: application/json
- Query parameters:
- bucket: InfluxDB bucket name
- precision: timestamp precision (default is
ns)
- Request body: Line protocol as plain text
The following example uses cURL and the InfluxDB v2 API to write line protocol to InfluxDB:
response=$(curl --silent --write-out "%{response_code}:-%{errormsg}" \
"https://cloud2.influxdata.com
/api/v2/write?bucket=get-started&precision=s" \
--header "Authorization: Token DATABASE_TOKEN" \
--header "Content-Type: text/plain; charset=utf-8" \
--header "Accept: application/json" \
--data-binary "
home,room=Living\ Room temp=21.1,hum=35.9,co=0i 1641024000
home,room=Kitchen temp=21.0,hum=35.9,co=0i 1641024000
home,room=Living\ Room temp=21.4,hum=35.9,co=0i 1641027600
home,room=Kitchen temp=23.0,hum=36.2,co=0i 1641027600
home,room=Living\ Room temp=21.8,hum=36.0,co=0i 1641031200
home,room=Kitchen temp=22.7,hum=36.1,co=0i 1641031200
home,room=Living\ Room temp=22.2,hum=36.0,co=0i 1641034800
home,room=Kitchen temp=22.4,hum=36.0,co=0i 1641034800
home,room=Living\ Room temp=22.2,hum=35.9,co=0i 1641038400
home,room=Kitchen temp=22.5,hum=36.0,co=0i 1641038400
home,room=Living\ Room temp=22.4,hum=36.0,co=0i 1641042000
home,room=Kitchen temp=22.8,hum=36.5,co=1i 1641042000
home,room=Living\ Room temp=22.3,hum=36.1,co=0i 1641045600
home,room=Kitchen temp=22.8,hum=36.3,co=1i 1641045600
home,room=Living\ Room temp=22.3,hum=36.1,co=1i 1641049200
home,room=Kitchen temp=22.7,hum=36.2,co=3i 1641049200
home,room=Living\ Room temp=22.4,hum=36.0,co=4i 1641052800
home,room=Kitchen temp=22.4,hum=36.0,co=7i 1641052800
home,room=Living\ Room temp=22.6,hum=35.9,co=5i 1641056400
home,room=Kitchen temp=22.7,hum=36.0,co=9i 1641056400
home,room=Living\ Room temp=22.8,hum=36.2,co=9i 1641060000
home,room=Kitchen temp=23.3,hum=36.9,co=18i 1641060000
home,room=Living\ Room temp=22.5,hum=36.3,co=14i 1641063600
home,room=Kitchen temp=23.1,hum=36.6,co=22i 1641063600
home,room=Living\ Room temp=22.2,hum=36.4,co=17i 1641067200
home,room=Kitchen temp=22.7,hum=36.5,co=26i 1641067200
")
# Format the response code and error message output.
response_code=${response%%:-*}
errormsg=${response#*:-}
# Remove leading and trailing whitespace from errormsg
errormsg=$(echo "${errormsg}" | tr -d '[:space:]')
echo "$response_code"
if [[ $errormsg ]]; then
echo "$errormsg"
fiReplace the following:
API_TOKEN: a token with sufficient permissions to the specified bucket
If successful, the output is an HTTP 204 No Content status code; otherwise,
the error status code and failure message.
204To write data to InfluxDB Cloud Serverless using Python, use the
influxdb_client_3 module.
The following steps include setting up a Python virtual environment to scope
dependencies to your current project.
Create a module directory and navigate into it–for example:
mkdir -p influxdb_py_client && cd influxdb_py_clientSetup your Python virtual environment. Inside of your module directory:
python -m venv envs/virtual-envActivate the virtual environment.
source ./envs/virtual-env/bin/activateInstall the client library package:
pip install influxdb3-python
The influxdb3-python package provides the influxdb_client_3 module and
also installs the
pyarrow package for
working with Arrow data returned from queries.
In your terminal or editor, create a new file for your code–for example:
write.py.touch write.pyInside of
write.py, enter the following sample code:from influxdb_client_3 import InfluxDBClient3 import os # INFLUX_TOKEN is an environment variable you assigned to your # API WRITE token value. token = os.getenv('INFLUX_TOKEN') # host is the URL hostname without protocol or trailing slash client = InfluxDBClient3( host='cloud2.influxdata.com
‘, token=token, database=‘get-started’ )
lines = [
"home,room=Living\ Room temp=21.1,hum=35.9,co=0i 1719924000",
"home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719924000",
"home,room=Living\ Room temp=21.4,hum=35.9,co=0i 1719927600",
"home,room=Kitchen temp=23.0,hum=36.2,co=0i 1719927600",
"home,room=Living\ Room temp=21.8,hum=36.0,co=0i 1719931200",
"home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719931200",
"home,room=Living\ Room temp=22.2,hum=36.0,co=0i 1719934800",
"home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719934800",
"home,room=Living\ Room temp=22.2,hum=35.9,co=0i 1719938400",
"home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719938400",
"home,room=Living\ Room temp=22.4,hum=36.0,co=0i 1719942000",
"home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719942000",
"home,room=Living\ Room temp=22.3,hum=36.1,co=0i 1719945600",
"home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719945600",
"home,room=Living\ Room temp=22.3,hum=36.1,co=1i 1719949200",
"home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719949200",
"home,room=Living\ Room temp=22.4,hum=36.0,co=4i 1719952800",
"home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719952800",
"home,room=Living\ Room temp=22.6,hum=35.9,co=5i 1719956400",
"home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719956400",
"home,room=Living\ Room temp=22.8,hum=36.2,co=9i 1719960000",
"home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719960000",
"home,room=Living\ Room temp=22.5,hum=36.3,co=14i 1719963600",
"home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719963600",
"home,room=Living\ Room temp=22.2,hum=36.4,co=17i 1719967200",
"home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719967200"
]
client.write(lines,write_precision=’s')
The sample does the following:
1. Imports the `InfluxDBClient3` object from the `influxdb_client_3` module.
2. Calls the `InfluxDBClient3()` constructor to instantiate an InfluxDB client
configured with the following credentials:
- **`host`**: InfluxDB Cloud Serverless region hostname (URL without protocol
or trailing slash)
- **`token`**: a [token](/influxdb3/cloud-serverless/admin/tokens/) with
write access to the specified bucket.
_Store this in a secret store or environment variable to avoid exposing
the raw token string._
- **`database`**: the name of the InfluxDB Cloud Serverless bucket to write to
3. Defines a list of line protocol strings where each string represents a data record.
4. Calls the `client.write()` method with the line protocol record list and write options.
**Because the timestamps in the sample line protocol are in second
precision, the example passes the `write_precision='s'` option
to set the
[timestamp precision](/influxdb3/cloud-serverless/reference/glossary/#timestamp-precision)
to seconds.**
</code></pre>
<ol start="7">
<li>
<p>To execute the module and write line protocol to your InfluxDB Cloud Serverless
bucket, enter the following command in your terminal:</p>
<!--pytest.mark.skip-->
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash"><span class="line"><span class="cl">python write.py</span></span></code></pre></div>
</li>
</ol>
</div>
If successful, the output is the success message; otherwise, error details and
the failure message.
<!----------------------------- END PYTHON CONTENT ---------------------------->
To write data to InfluxDB Cloud Serverless using Go, use the
InfluxDB 3 influxdb3-go client library package.
Inside of your project directory, create a new module directory and navigate
into it.
mkdir -p influxdb_go_client && cd influxdb_go_client
Initialize a new Go module in the directory.
go mod init influxdb_go_client
In your terminal or editor, create a new file for your code–for example:
write.go.
touch write.go
Inside of write.go, enter the following sample code:
package main
import (
"context"
"os"
"fmt"
"log"
"github.com/InfluxCommunity/influxdb3-go/v2/influxdb3"
)
// Write line protocol data to InfluxDB
func WriteLineProtocol() error {
// INFLUX_TOKEN is an environment variable you assigned to your
// API WRITE token value.
token := os.Getenv("INFLUX_TOKEN")
database := os.Getenv("INFLUX_DATABASE")
// Initialize a client with URL and token,
// and set the timestamp precision for writes.
client, err := influxdb3.New(influxdb3.ClientConfig{
Host: "https://cloud2.influxdata.com
“,
Token: token,
Database: database,
WriteOptions: &influxdb3.WriteOptions{Precision: lineprotocol.Second},
})
// Close the client when the function returns.
defer func(client *influxdb3.Client) {
err := client.Close()
if err != nil {
panic(err)
}
}(client)
// Define line protocol records to write.
// Use a raw string literal (denoted by backticks)
// to preserve backslashes and prevent interpretation
// of escape sequences–for example, escaped spaces in tag values.
lines := […]string{
home,room=Living\ Room temp=21.1,hum=35.9,co=0i 1719124000,
home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719124000,
home,room=Living\ Room temp=21.4,hum=35.9,co=0i 1719127600,
home,room=Kitchen temp=23.0,hum=36.2,co=0i 1719127600,
home,room=Living\ Room temp=21.8,hum=36.0,co=0i 1719131200,
home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719131200,
home,room=Living\ Room temp=22.2,hum=36.0,co=0i 1719134800,
home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719134800,
home,room=Living\ Room temp=22.2,hum=35.9,co=0i 1719138400,
home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719138400,
home,room=Living\ Room temp=22.4,hum=36.0,co=0i 1719142000,
home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719142000,
home,room=Living\ Room temp=22.3,hum=36.1,co=0i 1719145600,
home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719145600,
home,room=Living\ Room temp=22.3,hum=36.1,co=1i 1719149200,
home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719149200,
home,room=Living\ Room temp=22.4,hum=36.0,co=4i 1719152800,
home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719152800,
home,room=Living\ Room temp=22.6,hum=35.9,co=5i 1719156400,
home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719156400,
home,room=Living\ Room temp=22.8,hum=36.2,co=9i 1719160000,
home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719160000,
home,room=Living\ Room temp=22.5,hum=36.3,co=14i 1719163600,
home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719163600,
home,room=Living\ Room temp=22.2,hum=36.4,co=17i 1719167200,
home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719167200,
}
// Iterate over the lines array and write each line
// separately to InfluxDB
for _, record := range lines {
err = client.Write(context.Background(), []byte(record))
if err != nil {
log.Fatalf("Error writing line protocol: %v", err)
}
}
if err != nil {
panic(err)
}
fmt.Println("Data has been written successfully.")
return nil
}
The sample does the following:
1. Imports required packages.
2. Defines a `WriteLineProtocol()` function that does the following:
1. To instantiate the client, calls the
`influxdb3.New(influxdb3.ClientConfig)` function and passes the following:
- **`Host`**: your InfluxDB Cloud Serverless region URL
- **`Token`**: a [token](/influxdb3/cloud-serverless/admin/tokens/)
with write access to the specified bucket. _Store this in a
secret store or environment variable to avoid exposing the raw
token string._
- **`WriteOptions`**: `influxdb3.WriteOptions` options for writing
to InfluxDB.
**Because the timestamps in the sample line protocol are in second
precision, the example passes the `Precision: lineprotocol.Second`
option to set the
[timestamp precision](/influxdb3/cloud-serverless/reference/glossary/#timestamp-precision)
to seconds.**
2. Defines a deferred function that closes the client when the function
returns.
3. Defines an array of line protocol strings where each string
represents a data record.
4. Iterates through the array of line protocol and calls the write
client's `Write()` method to write each line of line protocol
separately to InfluxDB.
</code></pre>
<ol start="5">
<li>
<p>In your editor, create a <code>main.go</code> file and enter the following sample code
that calls the <code>WriteLineProtocol()</code> function:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-go" data-lang="go"><span class="line"><span class="cl"><span class="kn">package</span><span class="w"> </span><span class="nx">main</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="c1">// Module main function</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="kd">func</span><span class="w"> </span><span class="nf">main</span><span class="p">()</span><span class="w"> </span><span class="p">{</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w"> </span><span class="nf">WriteLineProtocol</span><span class="p">()</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="p">}</span></span></span></code></pre></div>
</li>
<li>
<p>To install dependencies and write the data to your InfluxDB Cloud Serverless bucket,
enter the following command into your terminal:</p>
<!--pytest.mark.skip-->
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-sh" data-lang="sh"><span class="line"><span class="cl">go mod tidy <span class="o">&&</span> go run influxdb_go_client</span></span></code></pre></div>
</li>
</ol>
<p>If successful, the output is the success message; otherwise, error details and
the failure message.</p>
</div>
<!------------------------------- END GO CONTENT ------------------------------>
If you haven’t already, follow the instructions for
Downloading and installing Node.js and npm
for your system.
In your terminal, enter the following command to create a
influxdb_js_client directory for your project:
mkdir influxdb_js_client && cd influxdb_js_client
Inside of influxdb_js_client, enter the following command to initialize a
package. This example configures the package to use
ECMAScript modules (ESM).
npm init -y; npm pkg set type="module"
Install the @influxdata/influxdb3-client JavaScript client library as a
dependency to your project.
npm install --save @influxdata/influxdb3-client
In your terminal or editor, create a write.js file.
touch write.js
Inside of write.js, enter the following sample code:
// write.js
import { InfluxDBClient } from "@influxdata/influxdb3-client";
/**
* Set InfluxDB credentials.
*/
const host = 'cloud2.influxdata.com
‘;
const database = ‘get-started’;
/**
* INFLUX_TOKEN is an environment variable you assigned to your
* API WRITE token value.
*/
const token = process.env.INFLUX_TOKEN;
/**
* Write line protocol to InfluxDB using the JavaScript client library.
*/
export async function writeLineProtocol() {
/**
* Instantiate an InfluxDBClient
*/
const client = new InfluxDBClient({ host, token });
/**
- Define line protocol records to write.
*/
const records = [
home,room=Living\\ Room temp=21.1,hum=35.9,co=0i 1719124000,
home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719124000,
home,room=Living\\ Room temp=21.4,hum=35.9,co=0i 1719127600,
home,room=Kitchen temp=23.0,hum=36.2,co=0 1719127600,
home,room=Living\\ Room temp=21.8,hum=36.0,co=0i 1719131200,
home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719131200,
home,room=Living\\ Room temp=22.2,hum=36.0,co=0i 1719134800,
home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719134800,
home,room=Living\\ Room temp=22.2,hum=35.9,co=0i 1719138400,
home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719138400,
home,room=Living\\ Room temp=22.4,hum=36.0,co=0i 1719142000,
home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719142000,
home,room=Living\\ Room temp=22.3,hum=36.1,co=0i 1719145600,
home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719145600,
home,room=Living\\ Room temp=22.3,hum=36.1,co=1i 1719149200,
home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719149200,
home,room=Living\\ Room temp=22.4,hum=36.0,co=4i 1719152800,
home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719152800,
home,room=Living\\ Room temp=22.6,hum=35.9,co=5i 1719156400,
home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719156400,
home,room=Living\\ Room temp=22.8,hum=36.2,co=9i 1719160000,
home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719160000,
home,room=Living\\ Room temp=22.5,hum=36.3,co=14i 1719163600,
home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719163600,
home,room=Living\\ Room temp=22.2,hum=36.4,co=17i 1719167200,
home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719167200,
];
/**
- Creates an array that contains separate write request promises
- for all the records.
*/
const writePromises = records.map((record) => {
return client.write(record, database, "", { precision: "s" })
.then(() =>
Data has been written successfully: ${record},
() => Failed writing data: ${record});
});
/**
- Wait for all the write promises to settle, and then output the results.
*/
const writeResults = await Promise.allSettled(writePromises);
writeResults.forEach(write => console.log(write.value));
/** Close the client to release resources. */
await client.close();
}
The sample code does the following:
1. Imports the `InfluxDBClient` class.
2. Calls the `new InfluxDBClient()` constructor and passes a
`ClientOptions` object to instantiate a client configured with InfluxDB
credentials.
- **`host`**: your InfluxDB Cloud Serverless region URL
- **`token`**: a [token](/influxdb3/cloud-serverless/admin/tokens/)
with write access to the specified bucket.
_Store this in a secret store or environment variable to avoid exposing
the raw token string._
3. Defines a list of line protocol strings where each string represents a
data record.
4. Calls the client's `write()` method for each record, defines the success
or failure message to return, and collects the pending promises into the
`writePromises` array. Each call to `write()` passes the following
arguments:
- **`record`**: the line protocol record
- **`database`**: the name of the InfluxDB Cloud Serverless bucket to write to
- **`{precision}`**: a `WriteOptions` object that sets the `precision` value.
**Because the timestamps in the sample line protocol are in second
precision, the example passes `s` as the `precision` value to set the
write
[timestamp precision](/influxdb3/cloud-serverless/reference/glossary/#timestamp-precision)
to seconds.**
5. Calls `Promise.allSettled()` with the promises array to pause execution
until the promises have completed, and then assigns the array containing
success and failure messages to a `writeResults` constant.
6. Iterates over and prints the messages in `writeResults`.
7. Closes the client to release resources.
</code></pre>
<ol start="7">
<li>
<p>In your terminal or editor, create an <code>index.js</code> file.</p>
</li>
<li>
<p>Inside of <code>index.js</code>, enter the following sample code to import and call
<code>writeLineProtocol()</code>:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-js" data-lang="js"><span class="line"><span class="cl"><span class="c1">// index.js
</span></span></span><span class="line"><span class="cl"><span class="kr">import</span> <span class="p">{</span> <span class="nx">writeLineProtocol</span> <span class="p">}</span> <span class="nx">from</span> <span class="s2">"./write.js"</span><span class="p">;</span>
</span></span><span class="line"><span class="cl">
</span></span><span class="line"><span class="cl"><span class="cm">/**
</span></span></span><span class="line"><span class="cl"><span class="cm">* Execute the client functions.
</span></span></span><span class="line"><span class="cl"><span class="cm">*/</span>
</span></span><span class="line"><span class="cl"><span class="kr">async</span> <span class="kd">function</span> <span class="nx">main</span><span class="p">()</span> <span class="p">{</span>
</span></span><span class="line"><span class="cl"> <span class="cm">/** Write line protocol data to InfluxDB. */</span>
</span></span><span class="line"><span class="cl"> <span class="kr">await</span> <span class="nx">writeLineProtocol</span><span class="p">();</span>
</span></span><span class="line"><span class="cl"><span class="p">}</span>
</span></span><span class="line"><span class="cl">
</span></span><span class="line"><span class="cl"><span class="nx">main</span><span class="p">();</span></span></span></code></pre></div>
</li>
<li>
<p>In your terminal, execute <code>index.mjs</code> to write to InfluxDB Cloud Serverless:</p>
<!--pytest-codeblocks:cont-->
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-sh" data-lang="sh"><span class="line"><span class="cl">node index.js</span></span></code></pre></div>
</li>
</ol>
</div>
If successful, the output is the success message; otherwise, error details and
the failure message.
<!---------------------------- END NODE.JS CONTENT --------------------------->
If you haven’t already, follow the
Microsoft.com download instructions
to install .NET and the dotnet CLI.
In your terminal, create an executable C# project using the .NET console
template.
dotnet new console --name influxdb_csharp_client
Change into the generated influxdb_csharp_client directory.
cd influxdb_csharp_client
Run the following command to install the latest version of the InfluxDB 3 C#
client library.
dotnet add package InfluxDB3.Client
In your editor, create a Write.cs file and enter the following sample code:
// Write.cs
using System;
using System.Threading.Tasks;
using InfluxDB3.Client;
using InfluxDB3.Client.Query;
namespace InfluxDBv3;
public class Write
{
/**
* Writes line protocol to InfluxDB using the C# .NET client
* library.
*/
public static async Task WriteLines()
{
// Set InfluxDB credentials
const string host = "https://cloud2.influxdata.com
“;
string? database = “get-started”;
/**
* INFLUX_TOKEN is an environment variable you assigned to your
* WRITE token value.
*/
string? token = System.Environment
.GetEnvironmentVariable("INFLUX_TOKEN");
// Instantiate the InfluxDB client with credentials.
using var client = new InfluxDBClient(
host, token: token, database: database);
/**
* Define an array of line protocol strings to write.
* Include an additional backslash to preserve backslashes
* and prevent interpretation of escape sequences---for example,
* escaped spaces in tag values.
*/
string[] lines = new string[] {
"home,room=Living\\ Room temp=21.1,hum=35.9,co=0i 1719924000",
"home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719924000",
"home,room=Living\\ Room temp=21.4,hum=35.9,co=0i 1719927600",
"home,room=Kitchen temp=23.0,hum=36.2,co=0i 1719927600",
"home,room=Living\\ Room temp=21.8,hum=36.0,co=0i 1719931200",
"home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719931200",
"home,room=Living\\ Room temp=22.2,hum=36.0,co=0i 1719934800",
"home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719934800",
"home,room=Living\\ Room temp=22.2,hum=35.9,co=0i 1719938400",
"home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719938400",
"home,room=Living\\ Room temp=22.4,hum=36.0,co=0i 1719942000",
"home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719942000",
"home,room=Living\\ Room temp=22.3,hum=36.1,co=0i 1719945600",
"home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719945600",
"home,room=Living\\ Room temp=22.3,hum=36.1,co=1i 1719949200",
"home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719949200",
"home,room=Living\\ Room temp=22.4,hum=36.0,co=4i 1719952800",
"home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719952800",
"home,room=Living\\ Room temp=22.6,hum=35.9,co=5i 1719956400",
"home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719956400",
"home,room=Living\\ Room temp=22.8,hum=36.2,co=9i 1719960000",
"home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719960000",
"home,room=Living\\ Room temp=22.5,hum=36.3,co=14i 1719963600",
"home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719963600",
"home,room=Living\\ Room temp=22.2,hum=36.4,co=17i 1719967200",
"home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719967200"
};
// Write each record separately.
foreach (string line in lines)
{
// Write the record to InfluxDB with timestamp precision in seconds.
await client.WriteRecordAsync(
record: line, precision: WritePrecision.S);
Console.WriteLine(
"Data has been written successfully: {0,-30}", line);
}
}
}
The sample does the following:
1. Calls the `new InfluxDBClient()` constructor to instantiate a client configured
with InfluxDB credentials.
- **host**: your InfluxDB Cloud Serverless region URL
- **database**: the name of the InfluxDB Cloud Serverless bucket to write to
- **token**: a [token](/influxdb3/cloud-serverless/admin/tokens/) with write access to the specified bucket.
_Store this in a secret store or environment variable to avoid exposing the raw token string._
_The `using` statement ensures that the program disposes of the
client when it's no longer needed._
2. Defines an array of line protocol strings where each string represents a data record.
3. Calls the client's `WriteRecordAsync()` method to write each line protocol record to InfluxDB.
**Because the timestamps in the sample line protocol are in second
precision, the example passes the [`WritePrecision.S` enum value](https://github.com/InfluxCommunity/influxdb3-csharp/blob/main/Client/Write/WritePrecision.cs)
to the `precision:` option to set the [timestamp precision](/influxdb3/cloud-serverless/reference/glossary/#timestamp-precision) to seconds.**
</code></pre>
<ol start="6">
<li>
<p>In your editor, open the <code>Program.cs</code> file and replace its contents with the following:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-c#" data-lang="c#"><span class="line"><span class="cl"><span class="c1">// Program.cs</span>
</span></span><span class="line"><span class="cl">
</span></span><span class="line"><span class="cl"><span class="k">using</span> <span class="nn">System</span><span class="p">;</span>
</span></span><span class="line"><span class="cl"><span class="k">using</span> <span class="nn">System.Threading.Tasks</span><span class="p">;</span>
</span></span><span class="line"><span class="cl">
</span></span><span class="line"><span class="cl"><span class="k">namespace</span> <span class="nn">InfluxDBv3</span><span class="p">;</span>
</span></span><span class="line"><span class="cl">
</span></span><span class="line"><span class="cl"><span class="kd">public</span> <span class="k">class</span> <span class="nc">Program</span>
</span></span><span class="line"><span class="cl"><span class="p">{</span>
</span></span><span class="line"><span class="cl"> <span class="kd">public</span> <span class="kd">static</span> <span class="kd">async</span> <span class="n">Task</span> <span class="n">Main</span><span class="p">()</span>
</span></span><span class="line"><span class="cl"> <span class="p">{</span>
</span></span><span class="line"><span class="cl"> <span class="k">await</span> <span class="n">Write</span><span class="p">.</span><span class="n">WriteLineProtocol</span><span class="p">();</span>
</span></span><span class="line"><span class="cl"> <span class="p">}</span>
</span></span><span class="line"><span class="cl"><span class="p">}</span></span></span></code></pre></div>
<p>The <code>Program</code> class shares the same <code>InfluxDBv3</code> namespace as the <code>Write</code>
class you defined in the preceding step and defines a <code>Main()</code> function that
calls <code>Write.WriteLineProtocol()</code>. The <code>dotnet</code> CLI recognizes
<code>Program.Main()</code> as the entry point for your program.</p>
</li>
<li>
<p>To build and execute the program and write the line protocol to your
InfluxDB Cloud Serverless bucket, enter the following command in your terminal:</p>
<!--pytest.mark.skip-->
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-sh" data-lang="sh"><span class="line"><span class="cl">dotnet run</span></span></code></pre></div>
</li>
</ol>
<p>If successful, the output is the success message; otherwise, error details and
the failure message.</p>
<!---------------------------- END C# CONTENT --------------------------->
</div>
The tutorial assumes using Maven version 3.9 and Java version >= 15.
If you haven’t already, follow the instructions to download and install the
Java JDK and
Maven for your system.
In your terminal or editor, use Maven to generate a project–for example:
mvn org.apache.maven.plugins:maven-archetype-plugin:3.1.2:generate \
-DarchetypeArtifactId="maven-archetype-quickstart" \
-DarchetypeGroupId="org.apache.maven.archetypes" -DarchetypeVersion="1.4" \
-DgroupId="com.influxdbv3" -DartifactId="influxdb_java_client"
-Dversion="1.0"
Maven creates the <artifactId> directory (./influxdb_java_client) that
contains a pom.xml and scaffolding for your
com.influxdbv3.influxdb_java_client Java application.
In your terminal or editor, change into the ./influxdb_java_client
directory–for example:
cd ./influxdb_java_client
In your editor, open the pom.xml Maven configuration file and add the
com.influxdb.influxdb3-java client library into dependencies.
...
<dependencies>
...
<dependency>
<groupId>com.influxdb</groupId>
<artifactId>influxdb3-java</artifactId>
<version>0.1.0</version>
</dependency>
...
</dependencies>
To check your pom.xml for problems, run Maven’s validate command–for example,
enter the following in your terminal:
mvn validate
In your editor, navigate to the
./influxdb_java_client/src/main/java/com/influxdbv3 directory and create a
Write.java file.
In Write.java, enter the following sample code:
// Write.java
package com.influxdbv3;
import java.util.List;
import com.influxdb.v3.client.InfluxDBClient;
import com.influxdb.v3.client.write.WriteOptions;
import com.influxdb.v3.client.write.WritePrecision;
/**
* Writes line protocol to InfluxDB using the Java client
* library.
*/
public final class Write {
/**
* Write data to InfluxDB 3.
*/
private Write() {
//not called
}
/**
* @throws Exception
*/
public static void writeLineProtocol() throws Exception {
// Set InfluxDB credentials
final String host = "https://cloud2.influxdata.com
“;
final String database = “get-started”;
/**
* INFLUX_TOKEN is an environment variable you assigned to your
* WRITE token value.
*/
final char[] token = (System.getenv("INFLUX_TOKEN")).
toCharArray();
// Instantiate the InfluxDB client.
try (InfluxDBClient client = InfluxDBClient.getInstance(host,
token, database)) {
// Create a list of line protocol records.
final List<String> records = List.of(
"home,room=Living\\ Room temp=21.1,hum=35.9,co=0i 1719924000",
"home,room=Kitchen temp=21.0,hum=35.9,co=0i 1719924000",
"home,room=Living\\ Room temp=21.4,hum=35.9,co=0i 1719927600",
"home,room=Kitchen temp=23.0,hum=36.2,co=0i 1719927600",
"home,room=Living\\ Room temp=21.8,hum=36.0,co=0i 1719931200",
"home,room=Kitchen temp=22.7,hum=36.1,co=0i 1719931200",
"home,room=Living\\ Room temp=22.2,hum=36.0,co=0i 1719934800",
"home,room=Kitchen temp=22.4,hum=36.0,co=0i 1719934800",
"home,room=Living\\ Room temp=22.2,hum=35.9,co=0i 1719938400",
"home,room=Kitchen temp=22.5,hum=36.0,co=0i 1719938400",
"home,room=Living\\ Room temp=22.4,hum=36.0,co=0i 1719942000",
"home,room=Kitchen temp=22.8,hum=36.5,co=1i 1719942000",
"home,room=Living\\ Room temp=22.3,hum=36.1,co=0i 1719945600",
"home,room=Kitchen temp=22.8,hum=36.3,co=1i 1719945600",
"home,room=Living\\ Room temp=22.3,hum=36.1,co=1i 1719949200",
"home,room=Kitchen temp=22.7,hum=36.2,co=3i 1719949200",
"home,room=Living\\ Room temp=22.4,hum=36.0,co=4i 1719952800",
"home,room=Kitchen temp=22.4,hum=36.0,co=7i 1719952800",
"home,room=Living\\ Room temp=22.6,hum=35.9,co=5i 1719956400",
"home,room=Kitchen temp=22.7,hum=36.0,co=9i 1719956400",
"home,room=Living\\ Room temp=22.8,hum=36.2,co=9i 1719960000",
"home,room=Kitchen temp=23.3,hum=36.9,co=18i 1719960000",
"home,room=Living\\ Room temp=22.5,hum=36.3,co=14i 1719963600",
"home,room=Kitchen temp=23.1,hum=36.6,co=22i 1719963600",
"home,room=Living\\ Room temp=22.2,hum=36.4,co=17i 1719967200",
"home,room=Kitchen temp=22.7,hum=36.5,co=26i 1719967200"
);
/**
* Write each record separately to InfluxDB with timestamp
* precision in seconds.
* If no error occurs, print a success message.
* */
for (String record : records) {
client.writeRecord(record, new WriteOptions(null, null,
WritePrecision.S));
System.out.printf("Data has been written successfully:
%s%n", record);
}
}
}
}
The sample code does the following:
1. Imports the following classes:
- `java.util.List`;
- `com.influxdb.v3.client.InfluxDBClient`
- `com.influxdb.v3.client.write.WriteParameters`
- `com.influxdb.v3.client.write.WritePrecision`
2. Calls `InfluxDBClient.getInstance()` to instantiate a client configured
with InfluxDB credentials.
- **`host`**: your InfluxDB Cloud Serverless region URL
- **`database`**: the name of the InfluxDB Cloud Serverless bucket to write to
- **`token`**: a
[token](/influxdb3/cloud-serverless/admin/tokens/) with write access
to the specified bucket.
_Store this in a secret store or environment variable to avoid exposing
the raw token string._
3. Defines a list of line protocol strings where each string represents a
data record.
4. Calls the client's `writeRecord()` method to write each record
separately to InfluxDB.
**Because the timestamps in the sample line protocol are in second
precision, the example passes the
[`WritePrecision.S` enum value](https://github.com/InfluxCommunity/influxdb3-java/blob/main/src/main/java/com/influxdb/v3/client/write/WritePrecision.java)
as the `precision` argument to set the write
[timestamp precision](/influxdb3/cloud-serverless/reference/glossary/#timestamp-precision)
to seconds.**
</code></pre>
<ol start="8">
<li>
<p>In your editor, open the <code>App.java</code> file (created by Maven) and replace its
contents with the following sample code:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-java" data-lang="java"><span class="line"><span class="cl"><span class="c1">// App.java</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="kn">package</span><span class="w"> </span><span class="nn">com.influxdbv3</span><span class="p">;</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="cm">/**
</span></span></span><span class="line"><span class="cl"><span class="cm">* Execute the client functions.
</span></span></span><span class="line"><span class="cl"><span class="cm">*
</span></span></span><span class="line"><span class="cl"><span class="cm">*/</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="kd">public</span><span class="w"> </span><span class="kd">class</span> <span class="nc">App</span><span class="w"> </span><span class="p">{</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w"> </span><span class="cm">/**
</span></span></span><span class="line"><span class="cl"><span class="cm"> * @param args
</span></span></span><span class="line"><span class="cl"><span class="cm"> * @throws Exception
</span></span></span><span class="line"><span class="cl"><span class="cm"> */</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w"> </span><span class="kd">public</span><span class="w"> </span><span class="kd">static</span><span class="w"> </span><span class="kt">void</span><span class="w"> </span><span class="nf">main</span><span class="p">(</span><span class="kd">final</span><span class="w"> </span><span class="n">String</span><span class="o">[]</span><span class="w"> </span><span class="n">args</span><span class="p">)</span><span class="w"> </span><span class="kd">throws</span><span class="w"> </span><span class="n">Exception</span><span class="w"> </span><span class="p">{</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w"> </span><span class="c1">// Write data to InfluxDB 3.</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w"> </span><span class="n">Write</span><span class="p">.</span><span class="na">writeLineProtocol</span><span class="p">();</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="w"> </span><span class="p">}</span><span class="w">
</span></span></span><span class="line"><span class="cl"><span class="p">}</span></span></span></code></pre></div>
<ul>
<li>The <code>App</code> class and <code>Write</code> class are part of the same <code>com.influxdbv3</code>
package (your project <strong>groupId</strong>).</li>
<li><code>App</code> defines a <code>main()</code> function that calls <code>Write.writeLineProtocol()</code>.</li>
</ul>
</li>
<li>
<p>In your terminal or editor, use Maven to install dependencies and compile
the project code–for example:</p>
<!--pytest.mark.skip-->
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash"><span class="line"><span class="cl">mvn compile</span></span></code></pre></div>
</li>
<li>
<p>In your terminal or editor, execute <code>App.main()</code> to write to InfluxDB–for
example, using Maven:</p>
<!--pytest.mark.skip-->
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-sh" data-lang="sh"><span class="line"><span class="cl">mvn exec:java -Dexec.mainClass<span class="o">=</span><span class="s2">"com.influxdbv3.App"</span></span></span></code></pre></div>
</li>
</ol>
<p>If successful, the output is the success message; otherwise, error details and
the failure message.</p>
<!---------------------------- END JAVA CONTENT --------------------------->
</div>
View the written data
time room co hum temp 2022-01-01T08:00:00Z Kitchen 0 35.9 21 2022-01-01T09:00:00Z Kitchen 0 36.2 23 2022-01-01T10:00:00Z Kitchen 0 36.1 22.7 2022-01-01T11:00:00Z Kitchen 0 36 22.4 2022-01-01T12:00:00Z Kitchen 0 36 22.5 2022-01-01T13:00:00Z Kitchen 1 36.5 22.8 2022-01-01T14:00:00Z Kitchen 1 36.3 22.8 2022-01-01T15:00:00Z Kitchen 3 36.2 22.7 2022-01-01T16:00:00Z Kitchen 7 36 22.4 2022-01-01T17:00:00Z Kitchen 9 36 22.7 2022-01-01T18:00:00Z Kitchen 18 36.9 23.3 2022-01-01T19:00:00Z Kitchen 22 36.6 23.1 2022-01-01T20:00:00Z Kitchen 26 36.5 22.7 2022-01-01T08:00:00Z Living Room 0 35.9 21.1 2022-01-01T09:00:00Z Living Room 0 35.9 21.4 2022-01-01T10:00:00Z Living Room 0 36 21.8 2022-01-01T11:00:00Z Living Room 0 36 22.2 2022-01-01T12:00:00Z Living Room 0 35.9 22.2 2022-01-01T13:00:00Z Living Room 0 36 22.4 2022-01-01T14:00:00Z Living Room 0 36.1 22.3 2022-01-01T15:00:00Z Living Room 1 36.1 22.3 2022-01-01T16:00:00Z Living Room 4 36 22.4 2022-01-01T17:00:00Z Living Room 5 35.9 22.6 2022-01-01T18:00:00Z Living Room 9 36.2 22.8 2022-01-01T19:00:00Z Living Room 14 36.3 22.5 2022-01-01T20:00:00Z Living Room 17 36.4 22.2
Congratulations! You have written data to InfluxDB.
With data now stored in InfluxDB, let’s query it.
Was this page helpful?
Thank you for your feedback!
Support and feedback
Thank you for being part of our community!
We welcome and encourage your feedback and bug reports for InfluxDB Cloud Serverless and this documentation.
To find support, use the following resources:
Customers with an annual or support contract can contact InfluxData Support.
© 2026 InfluxData, Inc.
Select your InfluxDB Cloud Serverless region
Select your InfluxDB Cloud Serverless region and we’ll customize code examples for you.
AWS
For more information, see InfluxDB Cloud Serverless regions.
Thank you for your feedback!
Let us know what we can do better:
New in InfluxDB 3.8
Key enhancements in InfluxDB 3.8 and the InfluxDB 3 Explorer 1.6.
InfluxDB 3.8 is now available for both Core and Enterprise, alongside the
1.6 release of the InfluxDB 3 Explorer UI. This release is focused on
operational maturity and making InfluxDB easier to deploy, manage, and run
reliably in production.
For more information, check out:
InfluxDB Docker latest tag changing to InfluxDB 3 Core
On April 7, 2026, the latest tag for InfluxDB Docker images will
point to InfluxDB 3 Core. To avoid unexpected upgrades, use specific version
tags in your Docker deployments.If using Docker to install and run InfluxDB, the latest tag will point to
InfluxDB 3 Core. To avoid unexpected upgrades, use specific version tags in
your Docker deployments. For example, if using Docker to run InfluxDB v2,
replace the latest version tag with a specific version tag in your Docker
pull command–for example:
docker pull influxdb:2
InfluxDB Cloud Serverless
You are currently viewing documentation specific to InfluxDB Cloud
Serverless
powered by the v3 storage engine, which
offers different functionality than InfluxDB Cloud
powered by the TSM storage engine.
Are you using InfluxDB Cloud Serverless?
How to find out?
Visit your organization's homepage
and find the following at the bottom of the right column:
InfluxDB Cloud Serverless
Storage Engine Version 3